<?php if (Session::get("tipo_usuario") != "3"){ show_403();} ?>
<?php if ($_SERVER["REQUEST_METHOD"] != "POST"){ show_403();} ?>
<?php import_file(DIR_TEMPLATES."header.php", ["title" => "Editar Produto", "active_page" => "produtos"]); ?>
<?php import_file(DIR_MODELS."Model.class.php"); ?>

<?php 

	$id_produto = encrypt_decode(filter_input(INPUT_POST, "id_produto", FILTER_SANITIZE_STRING));

	$model = new Model();

	$result = $model->query("
		SELECT * FROM produto 
		WHERE 
			id_produto = :id
	", [
		":id" => $id_produto
	]);

	$dados = $result->fetch();

?>

<h4 class="mb-3">
	<i class="fa-regular fa-edit"></i> Editar Produto
</h4>

<div class="content-box">
	<div id="detalhamento" style="display: none;">
		<div class="card mb-3">
			<div class="card-header">
				<div class="card-title h5 mb-0">
					<i class="fa-regular fa-file-chart-line"></i> Detalhamento
				</div>
			</div>
			<div class="card-body">
				<div class="table-responsive">
					<table class="table table-bordered">
						<thead class="thead-light">
							<tr>
								<th class="text-center align-middle">Val. Produto</th>
								<th class="text-center align-middle">Val. Venda</th>
								<th class="text-center align-middle">Val. Real</th>
								<th class="text-center align-middle">Val. Rede</th>
								<th class="text-center align-middle">Val. Comissão</th>
								<th class="text-center align-middle">Val. Cashback</th>
								<th class="text-center align-middle">Desc. Cliente</th>
								<th class="text-center align-middle">Lucro Empresa</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td id="td-val-produto" class="text-center align-middle"></td>
								<td id="td-val-venda" class="text-center align-middle"></td>
								<td id="td-val-real" class="text-center align-middle"></td>
								<td id="td-val-rede" class="text-center align-middle"></td>
								<td id="td-val-comissao" class="text-center align-middle"></td>
								<td id="td-val-cashback" class="text-center align-middle"></td>
								<td id="td-desc-cliente" class="text-center align-middle"></td>
								<td id="td-lucro-empresa" class="text-center align-middle"></td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>

	<form action="<?php echo show_link("/editar-produto-supervisor/"); ?>" method="post" enctype="multipart/form-data">
		<div class="form-row align-items-center">
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="nome-produto">Nome</label>
					<input type="text" id="nome-produto" class="form-control" value="<?php echo $dados->nome_produto; ?>" disabled>
				</div>
			</div>
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="valor-produto">Valor</label>
					<div class="input-group">
						<div class="input-group-prepend">
							<div class="input-group-text">
								<i class="fa-regular fa-dollar-sign"></i>
							</div>
						</div>
						<input type="text" id="valor-produto" class="form-control detalhamento" value="<?php echo $dados->valor_produto; ?>" disabled>
					</div>
				</div>
			</div>
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="quantidade-produto">Quantidade<span class="text-danger">*</span></label>
					<input type="number" id="quantidade-produto" class="form-control" min="1" step="1" value="<?php echo $dados->quantidade_produto; ?>" disabled>
				</div>
			</div>
		</div>

		<div class="form-row align-items-center">
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="desc-empresa-produto">Desconto para Empresa</label>
					<div class="input-group">
						<div class="input-group-prepend">
							<div class="input-group-text">
								<i class="fa-regular fa-percent"></i>
							</div>
						</div>
						<input type="number" id="desc-empresa-produto" class="form-control detalhamento" min="0" max="100" step="0.01" value="<?php echo $dados->porcentagem_desc_empresa; ?>" disabled>
					</div>
				</div>
			</div>
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="desc-cliente-produto">Desconto para Cliente</label>
					<div class="input-group">
						<div class="input-group-prepend">
							<div class="input-group-text">
								<i class="fa-regular fa-percent"></i>
							</div>
						</div>
						<input type="number" name="desc_cliente_produto" id="desc-cliente-produto" class="form-control detalhamento" min="0" max="100" step="0.01" value="<?php echo $dados->porcentagem_desc_cliente; ?>">
					</div>
				</div>
			</div>
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="cashback-produto">Cashback</label>
					<div class="input-group">
						<div class="input-group-prepend">
							<div class="input-group-text">
								<i class="fa-regular fa-percent"></i>
							</div>
						</div>
						<input type="number" name="cashback_produto" id="cashback-produto" class="form-control detalhamento" min="0" max="100" step="0.01" value="<?php echo $dados->porcentagem_cashback; ?>">
					</div>
				</div>
			</div>
		</div>

		<div class="form-row">
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="plano-produto">Plano<span class="text-danger">*</span></label>
					<select name="id_plano" id="plano-produto" class="form-control detalhamento" required>
						<option value="">Selecione um...</option>
						<?php

							$result = $model->query("
								SELECT * FROM plano 
								WHERE 
									status_plano = 'S' 
								ORDER BY 
									nome_plano ASC
							");

							foreach ($result->fetchAll() as $value):

						?>
							<option value="<?php echo encrypt_encode($value->id_plano); ?>" data-porcentagem="<?php echo $value->porcentagem_valor_plano; ?>" data-comissao="<?php echo $value->porcentagem_comissao_plano; ?>"><?php echo $value->nome_plano; ?></option>
						<?php endforeach; ?>
					</select>
					<script>
						$(function(){
							$("#plano-produto").val("<?php echo encrypt_encode($dados->id_plano); ?>");
						});
					</script>
				</div>
			</div>
			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="categoria-produto">Categoria</label>
					<select id="categoria-produto" class="form-control detalhamento" disabled>
						<option value="">Selecione um...</option>
						<?php

							$result = $model->query("
								SELECT * FROM categoria 
								WHERE 
									status_categoria = 'S' 
								ORDER BY 
									nome_categoria ASC
							");

							foreach ($result->fetchAll() as $value):

						?>
							<option value="<?php echo encrypt_encode($value->id_categoria); ?>"><?php echo $value->nome_categoria; ?></option>
						<?php endforeach; ?>
					</select>
					<script>
						$(function(){
							$("#categoria-produto").val("<?php echo encrypt_encode($dados->id_categoria); ?>");
						});
					</script>
				</div>
			</div>

			<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
				<div class="form-group">
					<label for="subcategoria-produto">Subcategoria</label>
					<select id="subcategoria-produto" class="form-control" disabled>
						<option value="">Selecione um...</option>
						<?php

							$result = $model->query("
								SELECT * FROM subcategoria 
								WHERE 
									status_subcategoria = 'S' 
								ORDER BY 
									nome_subcategoria ASC
							");

							foreach ($result->fetchAll() as $value):

						?>
							<option value="<?php echo encrypt_encode($value->id_subcategoria); ?>"><?php echo $value->nome_subcategoria; ?></option>
						<?php endforeach; ?>
					</select>
					<script>
						$(function(){
							$("#subcategoria-produto").val("<?php echo encrypt_encode($dados->id_subcategoria); ?>");
						});
					</script>
				</div>
			</div>

			<?php if (GANHE_MAIS == "S"): ?>
				<div class="col-xl-4 col-lg-4 col-md-6 col-sm-12">
					<div class="form-group">
						<label for="ganhe-mais">Ganhe Mais<span class="text-danger">*</span></label>
						<select name="ganhe_mais" id="ganhe-mais" class="form-control" required>
							<option value="">Selecione um...</option>
							<option value="S">Sim</option>
							<option value="N">Não</option>
						</select>
					</div>
					<script>
						$(function(){
							$("#ganhe-mais").val("<?php echo $dados->ganhe_mais; ?>");
						});
					</script>
				</div>
			<?php endif; ?>
		</div>

		<div class="form-row align-items-center mb-3">
			<div class="col-xl-3 col-lg-3 col-md-4 col-sm-12 text-center text-md-left">
				<img src="<?php echo show_link($dados->imagem_produto); ?>" id="imagem-escolhida" class="img-fluid img-thumbnail my-2">
			</div>
			<div class="col-xl-9 col-lg-9 col-md-8 col-sm-12">
				<div class="form-group">
					<label for="imagem-anuncio">Imagem</label>
					<div class="input-group mb-3">
						<input type="text" id="diretorio-imagem" class="form-control" value="<?php echo $dados->imagem_produto; ?>" disabled>
						<div class="input-group-append">
							<button type="button" id="btn-procurar" class="btn btn-secondary" disabled>
								<i class="fa-regular fa-folder-open"></i> Procurar
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div id="imagens-adicionais"></div>

		<div class="form-group">
			<label for="descricao-produto">Descrição</label>
			<textarea id="descricao-produto" rows="8" class="form-control"><?php echo $dados->descricao_produto; ?></textarea>
		</div>

		<div class="form-group">
			<label for="observacao-produto">Observação</label>
			<textarea name="observacao_produto" id="observacao-produto" rows="8" class="form-control"><?php echo $dados->observacao_produto; ?></textarea>
		</div>

		<input type="hidden" name="id_produto" class="d-none" value="<?php echo encrypt_encode($id_produto); ?>">

		<button type="submit" class="btn btn-primary">
			<i class="fa-regular fa-save"></i> Salvar
		</button>

		<a href="<?php echo show_link("/todos-produtos/"); ?>" class="btn btn-secondary">
			<i class="fa-regular fa-arrow-left"></i> Voltar
		</a>
	</form>
</div>

<script>
	$("#valor-produto").mask("#.##0,00", {reverse: true});

	CKEDITOR.replace("descricao-produto");
	CKEDITOR.replace("observacao-produto");

	var count = 0;

	function adicionarImagem(){
		var html = `
			<div id="imagem-`+count+`" class="form-row align-items-center mb-3">
				<div class="col-xl-3 col-lg-3 col-md-4 col-sm-12 text-center text-md-left">
					<img src="<?php echo $dafault_image; ?>" id="imagem-escolhida-`+count+`" class="img-fluid img-thumbnail my-2">
				</div>
				<div class="col-xl-9 col-lg-9 col-md-8 col-sm-12">
					<div class="form-group">
						<label for="imagem-anuncio-`+count+`">Imagem<span class="text-danger">*</span></label>
						<div class="input-group mb-3">
							<input type="text" id="diretorio-imagem-`+count+`" class="form-control" readonly required>
							<div class="input-group-append">
								<button type="button" id="btn-procurar-`+count+`" class="btn btn-secondary" disabled>
									<i class="fa-regular fa-folder-open"></i> Procurar
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
		`;

		$("#imagens-adicionais").append(html);

		$("[data-toggle='tooltip']").tooltip();

		count++;
	}

	function mascaraDinheiro(valor){
		var novo_valor = String(valor);

		if (novo_valor.indexOf(".") != -1) {
			var aux = novo_valor.split(".");

			if (aux[1].length == 1) {
				aux[1] += "0";
			}
			else if (aux[1].length > 2){
				aux[1] = aux[1].substr(0,2);
			}

			return "R$ "+aux[0]+","+aux[1];
		}
		else if (isNaN(novo_valor)) {
			return "R$ 0,00";
		}
		else{
			return "R$ "+novo_valor+",00";
		}
	}

	function detalhamento(){
		var valor_produto = $("#valor-produto").val();
		valor_produto = valor_produto.replace(".", "");
		valor_produto = Number(valor_produto.replace(",", "."));

		var desc_empresa = $("#desc-empresa-produto").val();
		desc_empresa = desc_empresa/100;

		var desc_cliente = $("#desc-cliente-produto").val();
		desc_cliente = desc_cliente/100;

		var cashback = $("#cashback-produto").val();
		cashback = cashback/100;

		var id_plano = $("#plano-produto").val();
		var porcentagem_plano = Number($("#plano-produto > option[value='"+id_plano+"']").data("porcentagem"));
		var valor_plano = valor_produto * (porcentagem_plano/100);
		var porcentagem_comissao_plano = Number($("#plano-produto > option[value='"+id_plano+"']").data("comissao"));
		var comissao_plano = valor_produto * (porcentagem_comissao_plano/100);

		if (valor_produto != 0 || desc_empresa != 0 || desc_cliente != 0 || cashback != 0 || isNaN(valor_plano) == false || isNaN(comissao_plano) == false) {
			$("#detalhamento").show();

			var valor_real = (valor_produto - (valor_produto * desc_empresa));

			var lucro = (valor_produto * desc_empresa) - (comissao_plano + valor_plano + (valor_produto * desc_cliente) + ((valor_produto - (valor_produto * desc_cliente)) * cashback));

			$("#td-val-produto").text(mascaraDinheiro(valor_produto));
			$("#td-val-venda").text(mascaraDinheiro(valor_produto - (valor_produto * desc_cliente)));
			$("#td-val-rede").text(mascaraDinheiro(valor_plano));
			$("#td-val-comissao").text(mascaraDinheiro(comissao_plano));
			$("#td-desc-cliente").text(mascaraDinheiro(valor_produto * desc_cliente));
			$("#td-val-cashback").text(mascaraDinheiro((valor_produto - (valor_produto * desc_cliente)) * cashback));
			$("#td-val-real").text(mascaraDinheiro(valor_real));
			$("#td-lucro-empresa").text(mascaraDinheiro(lucro));
		}
		else{
			$("#detalhamento").fadeOut(0);
		}
	}

	$("input.detalhamento").keyup(function(){
		detalhamento();
	});

	$("input[type=number].detalhamento").click(function(){
		detalhamento();
	});

	$("select.detalhamento").change(function(){
		detalhamento();
	});

	$(function(){
		detalhamento();
		window.editorDescricao.isReadOnly = true;
	});
</script>

<script>
	$(function(){
		<?php

			$result = $model->query("
				SELECT * FROM imagem_produto
				WHERE
					id_produto = :id
			", [
				":id" => $id_produto
			]);

			$result->fetch();

			for ($i=0; $i < ($result->rowCount() - 1); $i++) {
				$j = $result->fetch();

				echo 'adicionarImagem();';
				echo '$("#imagem-escolhida-'.$i.'").attr("src", "'.show_link($j->diretorio_imagem_produto).'");';
				echo '$("#diretorio-imagem-'.$i.'").val("'.$j->diretorio_imagem_produto.'");';
			}

		?>
	});
</script>

<?php import_file(DIR_TEMPLATES."footer.php"); ?>